Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Constants.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Constants.h	(revision 108)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Constants.h	(revision 109)
@@ -50,5 +50,5 @@
     TYPE_CUSTOM                            = 0x9,       // 00000 - unit uniq    , type optionnal
     TYPE_BRANCH                            = 0xa,       // 00000 - unit multiple
-    TYPE_MEMORY                            = 0xb        // 00000 - unit uniq
+    TYPE_MEMORY                            = 0xb        // 00000 - unit uniq    , type exclusive
   } type_t;
 
@@ -57,17 +57,46 @@
 #  define MAX_TYPE                                 (1<<SIZE_TYPE)
 
+    // TYPE         | multiple? | Optionnal? | Exclusive? | Comment
+    //--------------+-----------+------------+------------+---------
+    // TYPE_ALU     |     X     |            |            |
+    // TYPE_SHIFT   |     X     |            |            | ror is optionnal
+    // TYPE_MOVE    |     X     |            |            | cmov is optionnal
+    // TYPE_TEST    |     X     |            |            |
+    // TYPE_MUL     |     X     |            |            |
+    // TYPE_DIV     |     X     |     X      |            |
+    // TYPE_EXTEND  |     X     |     X      |            |
+    // TYPE_FIND    |     X     |     X      |            |
+    // TYPE_SPECIAL |           |            |            | mac unit is optionnal
+    // TYPE_CUSTOM  |           |     X      |            |
+    // TYPE_BRANCH  |     X     |            |            |
+    // TYPE_MEMORY  |           |            |     X      |
+
 #  define is_type_valid(x) \
-  (( x == TYPE_ALU    ) or \
-   ( x == TYPE_SHIFT  ) or \
-   ( x == TYPE_MOVE   ) or \
-   ( x == TYPE_TEST   ) or \
-   ( x == TYPE_MUL    ) or \
-   ( x == TYPE_DIV    ) or \
-   ( x == TYPE_EXTEND ) or \
-   ( x == TYPE_FIND   ) or \
-   ( x == TYPE_SPECIAL) or \
-   ( x == TYPE_CUSTOM ) or \
-   ( x == TYPE_BRANCH ) or \
-   ( x == TYPE_MEMORY ))
+  ((x == TYPE_ALU    ) or \
+   (x == TYPE_SHIFT  ) or \
+   (x == TYPE_MOVE   ) or \
+   (x == TYPE_TEST   ) or \
+   (x == TYPE_MUL    ) or \
+   (x == TYPE_DIV    ) or \
+   (x == TYPE_EXTEND ) or \
+   (x == TYPE_FIND   ) or \
+   (x == TYPE_SPECIAL) or \
+   (x == TYPE_CUSTOM ) or \
+   (x == TYPE_BRANCH ) or \
+   (x == TYPE_MEMORY ))
+
+#  define is_type_uniq(x) \
+  ((x == TYPE_SPECIAL) or \
+   (x == TYPE_CUSTOM ) or \
+   (x == TYPE_MEMORY ))
+
+#  define is_type_optionnal(x) \
+  ((x == TYPE_DIV    ) or \
+   (x == TYPE_EXTEND ) or \
+   (x == TYPE_FIND   ) or \
+   (x == TYPE_CUSTOM ))
+
+#  define is_type_exclusive(x) \
+  ((x == TYPE_MEMORY ))
 
   //====================================================[ Operation ]=====
@@ -211,5 +240,5 @@
 #  define OPERATION_FIND_L_FL1                     0x2        // 000_0000 l.fl1
 
-#  define OPERATION_SPECIAL_L_NOP                  0xff       // 000_0000 l.nop   
+#  define OPERATION_SPECIAL_L_NOP                  0x7f       // 000_0000 l.nop   
 #  define OPERATION_SPECIAL_L_MFSPR                0x1        // 000_0001 l.mfspr
 #  define OPERATION_SPECIAL_L_MTSPR                0x2        // 000_0010 l.mtspr
@@ -223,5 +252,4 @@
 #  define OPERATION_SPECIAL_L_SYS                  0x41       // 100_0001 l.sys  
 #  define OPERATION_SPECIAL_L_TRAP                 0x42       // 100_0010 l.trap 
-
 
 #  define OPERATION_BRANCH_NONE                    0x1        // 000_0000 l.j
@@ -668,219 +696,219 @@
     {
       // ORBIS
-      INSTRUCTION_L_ADD,
-      INSTRUCTION_L_ADDC,
-      INSTRUCTION_L_ADDI,
-      INSTRUCTION_L_ADDIC,
-      INSTRUCTION_L_AND,
-      INSTRUCTION_L_ANDI,
-      INSTRUCTION_L_BF,
-      INSTRUCTION_L_BNF,
-      INSTRUCTION_L_CMOV,
-      INSTRUCTION_L_CSYNC,
-      INSTRUCTION_L_CUST1,
-      INSTRUCTION_L_CUST2,
-      INSTRUCTION_L_CUST3,
-      INSTRUCTION_L_CUST4,
-      INSTRUCTION_L_CUST5,
-      INSTRUCTION_L_CUST6,
-      INSTRUCTION_L_CUST7,
-      INSTRUCTION_L_CUST8,
-      INSTRUCTION_L_DIV,
-      INSTRUCTION_L_DIVU,
-      INSTRUCTION_L_EXTBS,
-      INSTRUCTION_L_EXTBZ,
-      INSTRUCTION_L_EXTHS,
-      INSTRUCTION_L_EXTHZ,
-      INSTRUCTION_L_EXTWS,
-      INSTRUCTION_L_EXTWZ,
-      INSTRUCTION_L_FF1,
-      INSTRUCTION_L_FL1,
-      INSTRUCTION_L_J,
-      INSTRUCTION_L_JAL,
-      INSTRUCTION_L_JALR,
-      INSTRUCTION_L_JR,
-      INSTRUCTION_L_LBS,
-      INSTRUCTION_L_LBZ,
-      INSTRUCTION_L_LD,
-      INSTRUCTION_L_LHS,
-      INSTRUCTION_L_LHZ,
-      INSTRUCTION_L_LWS,
-      INSTRUCTION_L_LWZ,
-      INSTRUCTION_L_MAC,
-      INSTRUCTION_L_MACI,
-      INSTRUCTION_L_MACRC,
-      INSTRUCTION_L_MFSPR,
-      INSTRUCTION_L_MOVHI,
-      INSTRUCTION_L_MSB,
-      INSTRUCTION_L_MSYNC,
-      INSTRUCTION_L_MTSPR,
-      INSTRUCTION_L_MUL,
-      INSTRUCTION_L_MULI,
-      INSTRUCTION_L_MULU,
-      INSTRUCTION_L_NOP,
-      INSTRUCTION_L_OR,
-      INSTRUCTION_L_ORI,
-      INSTRUCTION_L_PSYNC,
-      INSTRUCTION_L_RFE,
-      INSTRUCTION_L_ROR,
-      INSTRUCTION_L_RORI,
-      INSTRUCTION_L_SB,
-      INSTRUCTION_L_SD,
-      INSTRUCTION_L_SFEQ,
-      INSTRUCTION_L_SFEQI,
-      INSTRUCTION_L_SFGES,
-      INSTRUCTION_L_SFGESI,
-      INSTRUCTION_L_SFGEU,
-      INSTRUCTION_L_SFGEUI,
-      INSTRUCTION_L_SFGTS,
-      INSTRUCTION_L_SFGTSI,
-      INSTRUCTION_L_SFGTU,
-      INSTRUCTION_L_SFGTUI,
-      INSTRUCTION_L_SFLES,
-      INSTRUCTION_L_SFLESI,
-      INSTRUCTION_L_SFLEU,
-      INSTRUCTION_L_SFLEUI,
-      INSTRUCTION_L_SFLTS,
-      INSTRUCTION_L_SFLTSI,
-      INSTRUCTION_L_SFLTU,
-      INSTRUCTION_L_SFLTUI,
-      INSTRUCTION_L_SFNE,
-      INSTRUCTION_L_SFNEI,
-      INSTRUCTION_L_SH,
-      INSTRUCTION_L_SLL,
-      INSTRUCTION_L_SLLI,
-      INSTRUCTION_L_SRA,
-      INSTRUCTION_L_SRAI,
-      INSTRUCTION_L_SRL,
-      INSTRUCTION_L_SRLI,
-      INSTRUCTION_L_SUB,
-      INSTRUCTION_L_SW,
-      INSTRUCTION_L_SYS,
-      INSTRUCTION_L_TRAP,
-      INSTRUCTION_L_XOR,
-      INSTRUCTION_L_XORI,
-      // ORFPX
-      INSTRUCTION_LF_ADD_D,
-      INSTRUCTION_LF_ADD_S,
-      INSTRUCTION_LF_CUST1_D,
-      INSTRUCTION_LF_CUST1_S,
-      INSTRUCTION_LF_DIV_D,
-      INSTRUCTION_LF_DIV_S,
-      INSTRUCTION_LF_FTOI_D,
-      INSTRUCTION_LF_FTOI_S,
-      INSTRUCTION_LF_ITOF_D,
-      INSTRUCTION_LF_ITOF_S,
-      INSTRUCTION_LF_MADD_D,
-      INSTRUCTION_LF_MADD_S,
-      INSTRUCTION_LF_MUL_D,
-      INSTRUCTION_LF_MUL_S,
-      INSTRUCTION_LF_REM_D,
-      INSTRUCTION_LF_REM_S,
-      INSTRUCTION_LF_SFEQ_D,
-      INSTRUCTION_LF_SFEQ_S,
-      INSTRUCTION_LF_SFGE_D,
-      INSTRUCTION_LF_SFGE_S,
-      INSTRUCTION_LF_SFGT_D,
-      INSTRUCTION_LF_SFGT_S,
-      INSTRUCTION_LF_SFLE_D,
-      INSTRUCTION_LF_SFLE_S,
-      INSTRUCTION_LF_SFLT_D,
-      INSTRUCTION_LF_SFLT_S,
-      INSTRUCTION_LF_SFNE_D,
-      INSTRUCTION_LF_SFNE_S,
-      INSTRUCTION_LF_SUB_D,
-      INSTRUCTION_LF_SUB_S,
-      // ORVDX
-      INSTRUCTION_LV_ADD_B,
-      INSTRUCTION_LV_ADD_H,
-      INSTRUCTION_LV_ADDS_B,
-      INSTRUCTION_LV_ADDS_H,
-      INSTRUCTION_LV_ADDU_B,
-      INSTRUCTION_LV_ADDU_H,
-      INSTRUCTION_LV_ADDUS_B,
-      INSTRUCTION_LV_ADDUS_H,
-      INSTRUCTION_LV_ALL_EQ_B,
-      INSTRUCTION_LV_ALL_EQ_H,
-      INSTRUCTION_LV_ALL_GE_B,
-      INSTRUCTION_LV_ALL_GE_H,
-      INSTRUCTION_LV_ALL_GT_B,
-      INSTRUCTION_LV_ALL_GT_H,
-      INSTRUCTION_LV_ALL_LE_B,
-      INSTRUCTION_LV_ALL_LE_H,
-      INSTRUCTION_LV_ALL_LT_B,
-      INSTRUCTION_LV_ALL_LT_H,
-      INSTRUCTION_LV_ALL_NE_B,
-      INSTRUCTION_LV_ALL_NE_H,
-      INSTRUCTION_LV_AND,
-      INSTRUCTION_LV_ANY_EQ_B,
-      INSTRUCTION_LV_ANY_EQ_H,
-      INSTRUCTION_LV_ANY_GE_B,
-      INSTRUCTION_LV_ANY_GE_H,
-      INSTRUCTION_LV_ANY_GT_B,
-      INSTRUCTION_LV_ANY_GT_H,
-      INSTRUCTION_LV_ANY_LE_B,
-      INSTRUCTION_LV_ANY_LE_H,
-      INSTRUCTION_LV_ANY_LT_B,
-      INSTRUCTION_LV_ANY_LT_H,
-      INSTRUCTION_LV_ANY_NE_B,
-      INSTRUCTION_LV_ANY_NE_H,
-      INSTRUCTION_LV_AVG_B,
-      INSTRUCTION_LV_AVG_H,
-      INSTRUCTION_LV_CMP_EQ_B,
-      INSTRUCTION_LV_CMP_EQ_H,
-      INSTRUCTION_LV_CMP_GE_B,
-      INSTRUCTION_LV_CMP_GE_H,
-      INSTRUCTION_LV_CMP_GT_B,
-      INSTRUCTION_LV_CMP_GT_H,
-      INSTRUCTION_LV_CMP_LE_B,
-      INSTRUCTION_LV_CMP_LE_H,
-      INSTRUCTION_LV_CMP_LT_B,
-      INSTRUCTION_LV_CMP_LT_H,
-      INSTRUCTION_LV_CMP_NE_B,
-      INSTRUCTION_LV_CMP_NE_H,
-      INSTRUCTION_LV_CUST1,
-      INSTRUCTION_LV_CUST2,
-      INSTRUCTION_LV_CUST3,
-      INSTRUCTION_LV_CUST4,
-      INSTRUCTION_LV_MADDS_H,
-      INSTRUCTION_LV_MAX_B,
-      INSTRUCTION_LV_MAX_H,
-      INSTRUCTION_LV_MERGE_B,
-      INSTRUCTION_LV_MERGE_H,
-      INSTRUCTION_LV_MIN_B,
-      INSTRUCTION_LV_MIN_H,
-      INSTRUCTION_LV_MSUBS_H,
-      INSTRUCTION_LV_MULS_H,
-      INSTRUCTION_LV_NAND,
-      INSTRUCTION_LV_NOR,
-      INSTRUCTION_LV_OR,
-      INSTRUCTION_LV_PACK_B,
-      INSTRUCTION_LV_PACK_H,
-      INSTRUCTION_LV_PACKS_B,
-      INSTRUCTION_LV_PACKS_H,
-      INSTRUCTION_LV_PACKUS_B,
-      INSTRUCTION_LV_PACKUS_H,
-      INSTRUCTION_LV_PERM_N,
-      INSTRUCTION_LV_RL_B,
-      INSTRUCTION_LV_RL_H,
-      INSTRUCTION_LV_SLL,
-      INSTRUCTION_LV_SLL_B,
-      INSTRUCTION_LV_SLL_H,
-      INSTRUCTION_LV_SRA_B,
-      INSTRUCTION_LV_SRA_H,
-      INSTRUCTION_LV_SRL,
-      INSTRUCTION_LV_SRL_B,
-      INSTRUCTION_LV_SRL_H,
-      INSTRUCTION_LV_SUB_B,
-      INSTRUCTION_LV_SUB_H,
-      INSTRUCTION_LV_SUBS_B,
-      INSTRUCTION_LV_SUBS_H,
-      INSTRUCTION_LV_SUBU_B,
-      INSTRUCTION_LV_SUBU_H,
-      INSTRUCTION_LV_SUBUS_B,
-      INSTRUCTION_LV_SUBUS_H,
-      INSTRUCTION_LV_UNPACK_B,
-      INSTRUCTION_LV_UNPACK_H,
-      INSTRUCTION_LV_XOR
+      INSTRUCTION_L_ADD,                         //0
+      INSTRUCTION_L_ADDC,                        //1
+      INSTRUCTION_L_ADDI,                        //2
+      INSTRUCTION_L_ADDIC,                       //3
+      INSTRUCTION_L_AND,                         //4
+      INSTRUCTION_L_ANDI,                        //5
+      INSTRUCTION_L_BF,                          //6
+      INSTRUCTION_L_BNF,                         //7
+      INSTRUCTION_L_CMOV,                        //8
+      INSTRUCTION_L_CSYNC,                       //9
+      INSTRUCTION_L_CUST1,                       //10
+      INSTRUCTION_L_CUST2,                       //11
+      INSTRUCTION_L_CUST3,                       //12
+      INSTRUCTION_L_CUST4,                       //13
+      INSTRUCTION_L_CUST5,                       //14
+      INSTRUCTION_L_CUST6,                       //15
+      INSTRUCTION_L_CUST7,                       //16
+      INSTRUCTION_L_CUST8,                       //17
+      INSTRUCTION_L_DIV,                         //18
+      INSTRUCTION_L_DIVU,                        //19
+      INSTRUCTION_L_EXTBS,                       //20
+      INSTRUCTION_L_EXTBZ,                       //21
+      INSTRUCTION_L_EXTHS,                       //22
+      INSTRUCTION_L_EXTHZ,                       //23
+      INSTRUCTION_L_EXTWS,                       //24
+      INSTRUCTION_L_EXTWZ,                       //25
+      INSTRUCTION_L_FF1,                         //26
+      INSTRUCTION_L_FL1,                         //27
+      INSTRUCTION_L_J,                           //28
+      INSTRUCTION_L_JAL,                         //29
+      INSTRUCTION_L_JALR,                        //30
+      INSTRUCTION_L_JR,                          //31
+      INSTRUCTION_L_LBS,                         //32
+      INSTRUCTION_L_LBZ,                         //33
+      INSTRUCTION_L_LD,                          //34
+      INSTRUCTION_L_LHS,                         //35
+      INSTRUCTION_L_LHZ,                         //36
+      INSTRUCTION_L_LWS,                         //37
+      INSTRUCTION_L_LWZ,                         //38
+      INSTRUCTION_L_MAC,                         //39
+      INSTRUCTION_L_MACI,                        //40
+      INSTRUCTION_L_MACRC,                       //41
+      INSTRUCTION_L_MFSPR,                       //42
+      INSTRUCTION_L_MOVHI,                       //43
+      INSTRUCTION_L_MSB,                         //44
+      INSTRUCTION_L_MSYNC,                       //45
+      INSTRUCTION_L_MTSPR,                       //46
+      INSTRUCTION_L_MUL,                         //47
+      INSTRUCTION_L_MULI,                        //48
+      INSTRUCTION_L_MULU,                        //49
+      INSTRUCTION_L_NOP,                         //50
+      INSTRUCTION_L_OR,                          //51
+      INSTRUCTION_L_ORI,                         //52
+      INSTRUCTION_L_PSYNC,                       //53
+      INSTRUCTION_L_RFE,                         //54
+      INSTRUCTION_L_ROR,                         //55
+      INSTRUCTION_L_RORI,                        //56
+      INSTRUCTION_L_SB,                          //57
+      INSTRUCTION_L_SD,                          //58
+      INSTRUCTION_L_SFEQ,                        //59
+      INSTRUCTION_L_SFEQI,                       //60
+      INSTRUCTION_L_SFGES,                       //61
+      INSTRUCTION_L_SFGESI,                      //62
+      INSTRUCTION_L_SFGEU,                       //63
+      INSTRUCTION_L_SFGEUI,                      //64
+      INSTRUCTION_L_SFGTS,                       //65
+      INSTRUCTION_L_SFGTSI,                      //66
+      INSTRUCTION_L_SFGTU,                       //67
+      INSTRUCTION_L_SFGTUI,                      //68
+      INSTRUCTION_L_SFLES,                       //69
+      INSTRUCTION_L_SFLESI,                      //70
+      INSTRUCTION_L_SFLEU,                       //71
+      INSTRUCTION_L_SFLEUI,                      //72
+      INSTRUCTION_L_SFLTS,                       //73
+      INSTRUCTION_L_SFLTSI,                      //74
+      INSTRUCTION_L_SFLTU,                       //75
+      INSTRUCTION_L_SFLTUI,                      //76
+      INSTRUCTION_L_SFNE,                        //77
+      INSTRUCTION_L_SFNEI,                       //78
+      INSTRUCTION_L_SH,                          //79
+      INSTRUCTION_L_SLL,                         //80
+      INSTRUCTION_L_SLLI,                        //81
+      INSTRUCTION_L_SRA,                         //82
+      INSTRUCTION_L_SRAI,                        //83
+      INSTRUCTION_L_SRL,                         //84
+      INSTRUCTION_L_SRLI,                        //85
+      INSTRUCTION_L_SUB,                         //86
+      INSTRUCTION_L_SW,                          //87
+      INSTRUCTION_L_SYS,                         //88
+      INSTRUCTION_L_TRAP,                        //89
+      INSTRUCTION_L_XOR,                         //90
+      INSTRUCTION_L_XORI,                        //91
+      // ORFPX                                     
+      INSTRUCTION_LF_ADD_D,                      //92
+      INSTRUCTION_LF_ADD_S,                      //93
+      INSTRUCTION_LF_CUST1_D,                    //94
+      INSTRUCTION_LF_CUST1_S,                    //95
+      INSTRUCTION_LF_DIV_D,                      //96
+      INSTRUCTION_LF_DIV_S,                      //97
+      INSTRUCTION_LF_FTOI_D,                     //98
+      INSTRUCTION_LF_FTOI_S,                     //99
+      INSTRUCTION_LF_ITOF_D,                     //100
+      INSTRUCTION_LF_ITOF_S,                     //101
+      INSTRUCTION_LF_MADD_D,                     //102
+      INSTRUCTION_LF_MADD_S,                     //103
+      INSTRUCTION_LF_MUL_D,                      //104
+      INSTRUCTION_LF_MUL_S,                      //105
+      INSTRUCTION_LF_REM_D,                      //106
+      INSTRUCTION_LF_REM_S,                      //107
+      INSTRUCTION_LF_SFEQ_D,                     //108
+      INSTRUCTION_LF_SFEQ_S,                     //109
+      INSTRUCTION_LF_SFGE_D,                     //110
+      INSTRUCTION_LF_SFGE_S,                     //111
+      INSTRUCTION_LF_SFGT_D,                     //112
+      INSTRUCTION_LF_SFGT_S,                     //113
+      INSTRUCTION_LF_SFLE_D,                     //114
+      INSTRUCTION_LF_SFLE_S,                     //115
+      INSTRUCTION_LF_SFLT_D,                     //116
+      INSTRUCTION_LF_SFLT_S,                     //117
+      INSTRUCTION_LF_SFNE_D,                     //118
+      INSTRUCTION_LF_SFNE_S,                     //119
+      INSTRUCTION_LF_SUB_D,                      //120
+      INSTRUCTION_LF_SUB_S,                      //121
+      // ORVDX                                     
+      INSTRUCTION_LV_ADD_B,                      //122
+      INSTRUCTION_LV_ADD_H,                      //123
+      INSTRUCTION_LV_ADDS_B,                     //124
+      INSTRUCTION_LV_ADDS_H,                     //125
+      INSTRUCTION_LV_ADDU_B,                     //126
+      INSTRUCTION_LV_ADDU_H,                     //127
+      INSTRUCTION_LV_ADDUS_B,                    //128
+      INSTRUCTION_LV_ADDUS_H,                    //129
+      INSTRUCTION_LV_ALL_EQ_B,                   //130
+      INSTRUCTION_LV_ALL_EQ_H,                   //131
+      INSTRUCTION_LV_ALL_GE_B,                   //132
+      INSTRUCTION_LV_ALL_GE_H,                   //133
+      INSTRUCTION_LV_ALL_GT_B,                   //134
+      INSTRUCTION_LV_ALL_GT_H,                   //135
+      INSTRUCTION_LV_ALL_LE_B,                   //136
+      INSTRUCTION_LV_ALL_LE_H,                   //137
+      INSTRUCTION_LV_ALL_LT_B,                   //138
+      INSTRUCTION_LV_ALL_LT_H,                   //139
+      INSTRUCTION_LV_ALL_NE_B,                   //140
+      INSTRUCTION_LV_ALL_NE_H,                   //141
+      INSTRUCTION_LV_AND,                        //142
+      INSTRUCTION_LV_ANY_EQ_B,                   //143
+      INSTRUCTION_LV_ANY_EQ_H,                   //144
+      INSTRUCTION_LV_ANY_GE_B,                   //145
+      INSTRUCTION_LV_ANY_GE_H,                   //146
+      INSTRUCTION_LV_ANY_GT_B,                   //147
+      INSTRUCTION_LV_ANY_GT_H,                   //148
+      INSTRUCTION_LV_ANY_LE_B,                   //149
+      INSTRUCTION_LV_ANY_LE_H,                   //150
+      INSTRUCTION_LV_ANY_LT_B,                   //151
+      INSTRUCTION_LV_ANY_LT_H,                   //152
+      INSTRUCTION_LV_ANY_NE_B,                   //153
+      INSTRUCTION_LV_ANY_NE_H,                   //154
+      INSTRUCTION_LV_AVG_B,                      //155
+      INSTRUCTION_LV_AVG_H,                      //156
+      INSTRUCTION_LV_CMP_EQ_B,                   //157
+      INSTRUCTION_LV_CMP_EQ_H,                   //158
+      INSTRUCTION_LV_CMP_GE_B,                   //159
+      INSTRUCTION_LV_CMP_GE_H,                   //160
+      INSTRUCTION_LV_CMP_GT_B,                   //161
+      INSTRUCTION_LV_CMP_GT_H,                   //162
+      INSTRUCTION_LV_CMP_LE_B,                   //163
+      INSTRUCTION_LV_CMP_LE_H,                   //164
+      INSTRUCTION_LV_CMP_LT_B,                   //165
+      INSTRUCTION_LV_CMP_LT_H,                   //166
+      INSTRUCTION_LV_CMP_NE_B,                   //167
+      INSTRUCTION_LV_CMP_NE_H,                   //168
+      INSTRUCTION_LV_CUST1,                      //169
+      INSTRUCTION_LV_CUST2,                      //170
+      INSTRUCTION_LV_CUST3,                      //171
+      INSTRUCTION_LV_CUST4,                      //172
+      INSTRUCTION_LV_MADDS_H,                    //173
+      INSTRUCTION_LV_MAX_B,                      //174
+      INSTRUCTION_LV_MAX_H,                      //175
+      INSTRUCTION_LV_MERGE_B,                    //176
+      INSTRUCTION_LV_MERGE_H,                    //177
+      INSTRUCTION_LV_MIN_B,                      //178
+      INSTRUCTION_LV_MIN_H,                      //179
+      INSTRUCTION_LV_MSUBS_H,                    //180
+      INSTRUCTION_LV_MULS_H,                     //181
+      INSTRUCTION_LV_NAND,                       //182
+      INSTRUCTION_LV_NOR,                        //183
+      INSTRUCTION_LV_OR,                         //184
+      INSTRUCTION_LV_PACK_B,                     //185
+      INSTRUCTION_LV_PACK_H,                     //186
+      INSTRUCTION_LV_PACKS_B,                    //187
+      INSTRUCTION_LV_PACKS_H,                    //188
+      INSTRUCTION_LV_PACKUS_B,                   //189
+      INSTRUCTION_LV_PACKUS_H,                   //290
+      INSTRUCTION_LV_PERM_N,                     //291
+      INSTRUCTION_LV_RL_B,                       //292
+      INSTRUCTION_LV_RL_H,                       //293
+      INSTRUCTION_LV_SLL,                        //294
+      INSTRUCTION_LV_SLL_B,                      //295
+      INSTRUCTION_LV_SLL_H,                      //296
+      INSTRUCTION_LV_SRA_B,                      //297
+      INSTRUCTION_LV_SRA_H,                      //298
+      INSTRUCTION_LV_SRL,                        //299
+      INSTRUCTION_LV_SRL_B,                      //200
+      INSTRUCTION_LV_SRL_H,                      //201
+      INSTRUCTION_LV_SUB_B,                      //202
+      INSTRUCTION_LV_SUB_H,                      //203
+      INSTRUCTION_LV_SUBS_B,                     //204
+      INSTRUCTION_LV_SUBS_H,                     //205
+      INSTRUCTION_LV_SUBU_B,                     //206
+      INSTRUCTION_LV_SUBU_H,                     //207
+      INSTRUCTION_LV_SUBUS_B,                    //208
+      INSTRUCTION_LV_SUBUS_H,                    //209
+      INSTRUCTION_LV_UNPACK_B,                   //210
+      INSTRUCTION_LV_UNPACK_H,                   //211
+      INSTRUCTION_LV_XOR                         //212
     };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 108)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 109)
@@ -8,10 +8,10 @@
 #include "Common/include/ToString.h"
 
-#define MORPHEO_MAJOR_VERSION 0
-#define MORPHEO_MINOR_VERSION 2
-#define MORPHEO_REVISION      "108"
+#define MORPHEO_MAJOR_VERSION "0"
+#define MORPHEO_MINOR_VERSION "2"
+#define MORPHEO_REVISION      "109"
 #define MORPHEO_CODENAME      "Castor"
 
-#define MORPHEO_DATE_DAY      "12"  
+#define MORPHEO_DATE_DAY      "16"  
 #define MORPHEO_DATE_MONTH    "02"
 #define MORPHEO_DATE_YEAR     "2009" 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed	(revision 108)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h.sed	(revision 109)
@@ -8,6 +8,6 @@
 #include "Common/include/ToString.h"
 
-#define MORPHEO_MAJOR_VERSION 0
-#define MORPHEO_MINOR_VERSION 2
+#define MORPHEO_MAJOR_VERSION "0"
+#define MORPHEO_MINOR_VERSION "2"
 #define MORPHEO_REVISION      "@REVISION"
 #define MORPHEO_CODENAME      "Castor"